#include <string>

#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <errno.h>
#include <unistd.h>

#define __SERVER_PORT 4840

int main(int argc, char* argv[]) {
  /* Check correct args */
	if (argc < 2) {
		fprintf(stderr, "\nUsage: %s host\n\n", argv[0]);
		return 1;
	}

  /* Init socket */
	int h_sock = socket(AF_INET, SOCK_DGRAM, 0);
	if (h_sock < 0) {
		fprintf(stderr, "Error, socket() failed: %s\n", strerror(errno));
		return 1;
	}

  /* Resolve server */
	struct hostent *h_server = gethostbyname(argv[1]);
	if (h_server == NULL) {
		fprintf(stderr, "Error, unable to resolve '%s'\n", argv[1]);
		shutdown(h_sock, SHUT_RDWR);
		close(h_sock);
		return 1;
	}

  /* Init prime the socket struct for sending*/
	struct sockaddr_in addr;
	memset(&addr, 0, sizeof(addr));
	addr.sin_family = AF_INET;
	memcpy(&addr.sin_addr.s_addr, h_server->h_addr, h_server->h_length);
	addr.sin_port = htons(__SERVER_PORT);

  /* TODO: CREATE THE PAYLOAD HERE - FILL THIS IN */
	std::string payload = "payload";

  /* Send data */
	int n = sendto(h_sock, payload.c_str(), payload.size(), 0, (sockaddr*) &addr, sizeof(addr));

  /* make sure we sent */
	if (n < 0) {
		fprintf(stderr, "Error, send() failed: %s\n", strerror(errno));
		shutdown(h_sock, SHUT_RDWR);
		close(h_sock);
		return 1;
	}

  /* die gracefully */
	printf("Successfully sent.\n");
	shutdown(h_sock, SHUT_RDWR);
	close(h_sock);
	return 0;
}
